package com.zipcodewilmington.looplabs;

/**
 * Created by leon on 1/29/18.
 * @ATTENTION_TO_STUDENTS You are forbidden from modifying the signature of this class.
 */
public final class IntegerDuplicateDeleter extends DuplicateDeleter<Integer> {

    public IntegerDuplicateDeleter(Integer[] intArray) {
        super(intArray);
    }

    @Override
    public Integer[] removeDuplicates(int maxNumberOfDuplications) {

        int[] count = countOccurances();
        Integer[] result = new Integer[sizeOfNewArrayRange(count, maxNumberOfDuplications)];
        int index = 0;
        for (int i = 0; i < count.length; i++) {
            if(count[i] < maxNumberOfDuplications && count[i] != 0){
                for (int j = 0; j < count[i]; j++) {
                    result[index] = i;
                    index++;
                }
            }
        }
        return result;
    }

    @Override
    public Integer[] removeDuplicatesExactly(int exactNumberOfDuplications) {

        int[] count = countOccurances();
        Integer[] result = new Integer[sizeOfNewArrayExact(count, exactNumberOfDuplications)];
        int index = 0;
        for (int i = 0; i < count.length; i++) {
            if(count[i] != exactNumberOfDuplications && count[i] != 0){
                for (int j = 0; j < count[i]; j++) {
                    result[index] = i;
                            index++;
                }
            }
        }
        return result;
    }

    public int findMaxValue() {

        int max = this.array[0];
        for (int i = 0; i < this.array.length; i++) {
            if (max < this.array[i]) {
                max = this.array[i];
            }
        }
        return max;
    }

    public int[] countOccurances() {

        int[] count = new int[findMaxValue() + 1];
        for (int i : this.array) {
            int currentCount = count[i];
            currentCount = currentCount + 1;
            count[i] = currentCount;
        }
        return count;
    }

    @Override
    public int sizeOfNewArrayRange(int[] array, int min) {

        int size = 0;

        for (Integer i: array) {
            if(i < min) {
                size += i;
            }
        }
        return size;
    }

    @Override
    public int sizeOfNewArrayExact(int[] array, int num) {
        int size = 0;

        for (Integer i: array) {
            if(i != num) {
                size += i;
            }
        }
        return size;

    }


}
