package com.zipcodewilmington.looplabs;

/**
 * Created by leon on 1/28/18.
 * @ATTENTION_TO_STUDENTS You are forbidden from modifying the signature of this class.
 */
public final class StringDuplicateDeleter extends DuplicateDeleter<String> {


    public StringDuplicateDeleter(String[] intArray) {
        super(intArray);
    }

    @Override
    public String[] removeDuplicates(int maxNumberOfDuplications) {
        String[] keys = arrayOfSingleValues();
        int[] counts = countOccurances(keys);
        String[] result = new String[sizeOfNewArrayRange(counts, maxNumberOfDuplications)];
        int index = 0;

        for (int i = 0; i < counts.length; i++) {
            if(counts[i] < maxNumberOfDuplications){
                for (int j = 0; j < counts[i]; j++) {
                    result[index] = keys[i];
                    index++;
                }
            }
        }

        return result;
    }

    @Override
    public String[] removeDuplicatesExactly(int exactNumberOfDuplications) {
        String[] keys = arrayOfSingleValues();
        int[] counts = countOccurances(keys);
        String[] result = new String[sizeOfNewArrayExact(counts, exactNumberOfDuplications)];
        int index = 0;

        for (int i = 0; i < counts.length; i++) {
            if(counts[i] != exactNumberOfDuplications){
                for (int j = 0; j < counts[i]; j++) {
                    result[index] = keys[i];
                    index++;
                }
            }
        }

        return result;
    }

    public int[] countOccurances(String[] keys) {
        int[] counts = new int[keys.length];
        for(String s: this.array){
            counts[findIndex(keys, s)]++;
        }
        return counts;
    }

    public int findIndex(String[] keys, String string){
        for (int i = 0; i < keys.length; i++) {
            if(keys[i].equals(string))
                return i;
        }
        return -1;
    }

    @Override
    public int sizeOfNewArrayRange(int[] array, int min) {
        int size = 0;
        for(int i : array) {
            if(i < min)
                size += i;
        }
        return size;
    }

    @Override
    public int sizeOfNewArrayExact(int[] array, int num) {
        int size = 0;
        for(int i : array) {
            if(i != num)
                size += i;
        }
        return size;
    }

    public String[] arrayOfSingleValues() {
        String[] result = new String[this.array.length];
        int index = 0;
        for(String s: this.array) {
            if(!contains(s, result)) {
                result[index] = s;
                index++;
            }
        }
        return removeNullValues(result);
    }

    public boolean contains(String s, String[] array){
        for(String current : array) {
            try {
                if (current.equals(s))
                    return true;
            } catch (NullPointerException e) {
                return false;
            }
        }
        return false;
    }

    public String[] removeNullValues(String[] array){
        int count = 0;
        try {
            for (String current : array) {
                if(!current.equals(null))
                count++;
            }
        } catch (NullPointerException e) {

        }
        String[] result = new String[count];
        for (int i = 0; i < result.length; i++) {
            result[i] = array[i];
        }
        return result;
    }

}
